From: Pavel Reichl <preichl@redhat.com>
To: fstests@vger.kernel.org
Cc: zlang@redhad.com
Subject: [PATCH v3 1/1] generic: add test for boundary in xfs_attr_shortform_verify
Date: Sat, 12 Sep 2020 12:19:53 +0200 [thread overview]
Message-ID: <20200912101953.114089-2-preichl@redhat.com> (raw)
In-Reply-To: <20200912101953.114089-1-preichl@redhat.com>
Add a regression test to check that the boundary test
for the fixed-offset parts of xfs_attr_sf_entry
in xfs_attr_shortform_verify is not off by one.
This can be shown by:
touch file
setfattr -n user.a file
With help from Zorro. Thanks very much.
Signed-off-by: Pavel Reichl <preichl@redhat.com>
---
tests/generic/609 | 63 +++++++++++++++++++++++++++++++++++++++++++
tests/generic/609.out | 4 +++
tests/generic/group | 1 +
3 files changed, 68 insertions(+)
create mode 100755 tests/generic/609
create mode 100644 tests/generic/609.out
diff --git a/tests/generic/609 b/tests/generic/609
new file mode 100755
index 00000000..f048b2ba
--- /dev/null
+++ b/tests/generic/609
@@ -0,0 +1,63 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Red Hat, Inc. All Rights Reserved.
+#
+# FS QA Test 609
+#
+# Verify that metadata won't get corrupted when extended attribute
+# name of size one is set.
+#
+# This test verifies the problem fixed in kernel with commit
+# f4020438fab0 ("xfs: fix boundary test in xfs_attr_shortform_verify")
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_attrs
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+localfile="${SCRATCH_MNT}/testfile"
+
+touch "${localfile}"
+"${SETFATTR_PROG}" -n user.a "${localfile}"
+
+# Make sure that changes are written to disk
+echo 3 > /proc/sys/vm/drop_caches
+sleep 3
+
+# If the target bug isn't fixed, getfattr fails
+${GETFATTR_PROG} --absolute-names -n user.a $localfile | _filter_scratch
+
+# Make sure the filesystem isn't corrupted manually
+_scratch_unmount
+_check_scratch_fs
+
+status=0
+exit
diff --git a/tests/generic/609.out b/tests/generic/609.out
new file mode 100644
index 00000000..d4ae152d
--- /dev/null
+++ b/tests/generic/609.out
@@ -0,0 +1,4 @@
+QA output created by 609
+# file: SCRATCH_MNT/testfile
+user.a=""
+
diff --git a/tests/generic/group b/tests/generic/group
index aa969bcb..6fa83c13 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -611,3 +611,4 @@
606 auto attr quick dax
607 auto attr quick dax
608 auto attr quick dax
+609 auto attr quick
--
2.26.2
next prev parent reply other threads:[~2020-09-12 10:20 UTC|newest]
Thread overview: 5+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-09-12 10:19 [PATCH v3 0/1] generic: add test for boundary in xfs_attr_shortform_verify Pavel Reichl
2020-09-12 10:19 ` Pavel Reichl [this message]
2020-09-12 12:31 ` [PATCH v3 1/1] " Zorro Lang
2020-09-12 13:34 ` Zorro Lang
2020-09-13 16:36 ` Eryu Guan
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20200912101953.114089-2-preichl@redhat.com \
--to=preichl@redhat.com \
--cc=fstests@vger.kernel.org \
--cc=zlang@redhad.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox